<?php namespace App\Models;

use App\Entities\Administrativo\Administrativo;

class AdministrativoModel extends ModelEntity
{
    protected $table = 'administrativo';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'id_profissional',
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;

    public function registerAdministrativo (Administrativo &$administrativo) : void {
        $administrativo_data = $administrativo->toArray();
        unset($administrativo_data['id']);
        $id_new_administrativo = $this->insert($administrativo_data);
        $administrativo->setId($id_new_administrativo);

    }

    public function updateAdministrativoByID (int $id_paciente, Administrativo $administrativo) : bool {
        $data = $administrativo->toArray(true);
        if (count($data) > 0) {
            $binds = ['id_paciente' => $id_paciente];
            $sql = "
                UPDATE paciente
            ";
            $sql .= $this->generateUpdateSets($data, $binds);
            $sql .= 'WHERE paciente.id = :id_paciente:';
            $query = $this->db->query($sql, $binds);
            $errors = $this->errors();
            return !$errors;
        } else {
            return true;
        }
    }
}
